(define (domain upp)
  (:requirements :typing :action-costs)
  (:types
          size_t - object
          location_t - object
          side_t - object
          color_t - object
          image_t - object
          resource_t - object
          sheet_t - object
  )
  (:predicates
          (sheetsize ?sheet - sheet_t ?size - size_t)
          (location ?sheet - sheet_t ?location - location_t)
          (hasimage ?sheet - sheet_t ?side - side_t ?image - image_t)
          (sideup ?sheet - sheet_t ?side - side_t)
          (stackedin ?sheet - sheet_t ?location - location_t)
          (imagecolor ?image - image_t ?color - color_t)
          (notprintedwith ?sheet - sheet_t ?side - side_t ?color - color_t)
          (oppositeside ?side1 - side_t ?side2 - side_t)
          (available ?resource - resource_t)
          (prevsheet ?sheet1 - sheet_t ?sheet2 - sheet_t)
          (uninitialized )
          (is_constant_letter ?x - size_t)
          (is_constant_black ?x - color_t)
          (is_constant_color ?x - color_t)
          (is_constant_front ?x - side_t)
          (is_constant_back ?x - side_t)
          (is_constant_some_feeder_tray ?x - location_t)
          (is_constant_some_finisher_tray ?x - location_t)
          (is_constant_endcap_entry-blackcontainer_exit ?x - location_t)
          (is_constant_htmoverblack_entry-endcap_exit ?x - location_t)
          (is_constant_htmoverblack_exit-down_topentry ?x - location_t)
          (is_constant_colorcontainer_entry-down_bottomexit ?x - location_t)
          (is_constant_colorcontainer_exittoime-colorprinter_entry ?x - location_t)
          (is_constant_colorprinter_exit-colorcontainer_entryfromime ?x - location_t)
          (is_constant_colorcontainer_exit-up_bottomentry ?x - location_t)
          (is_constant_down_bottomentry-colorfeeder_exit ?x - location_t)
          (is_constant_blackcontainer_entry-blackfeeder_exit ?x - location_t)
          (is_constant_down_topexit-htmovercolor_entry ?x - location_t)
          (is_constant_htmovercolor_exit-up_topentry ?x - location_t)
          (is_constant_blackcontainer_exittoime-blackprinter_entry ?x - location_t)
          (is_constant_blackprinter_exit-blackcontainer_entryfromime ?x - location_t)
          (is_constant_finisher1_entry-up_topexit ?x - location_t)
          (is_constant_finisher2_entry-finisher1_exit ?x - location_t)
          (is_constant_finisher1_tray ?x - location_t)
          (is_constant_finisher2_exit ?x - location_t)
          (is_constant_finisher2_tray ?x - location_t)
          (is_constant_endcap-rsrc ?x - resource_t)
          (is_constant_htmoverblack-rsrc ?x - resource_t)
          (is_constant_colorcontainer-rsrc ?x - resource_t)
          (is_constant_colorprinter-rsrc ?x - resource_t)
          (is_constant_colorfeeder-rsrc ?x - resource_t)
          (is_constant_blackfeeder-rsrc ?x - resource_t)
          (is_constant_down-rsrc ?x - resource_t)
          (is_constant_htmovercolor-rsrc ?x - resource_t)
          (is_constant_blackcontainer-rsrc ?x - resource_t)
          (is_constant_blackprinter-rsrc ?x - resource_t)
          (is_constant_up-rsrc ?x - resource_t)
          (is_constant_finisher1-rsrc ?x - resource_t)
          (is_constant_finisher2-rsrc ?x - resource_t)
          )
  (:functions
          (total-cost ) - number
          )
  (:action initialize
          :parameters (
               ?const0 - resource_t
               ?const1 - resource_t
               ?const2 - resource_t
               ?const3 - resource_t
               ?const4 - resource_t
               ?const5 - resource_t
               ?const6 - resource_t
               ?const7 - resource_t
               ?const8 - resource_t
               ?const9 - resource_t
               ?const10 - resource_t
               ?const11 - resource_t
               ?const12 - resource_t
               )
          :precondition
               (and
                    (uninitialized)
                    (is_constant_finisher1-rsrc ?const0)
                    (is_constant_htmovercolor-rsrc ?const2)
                    (is_constant_finisher2-rsrc ?const3)
                    (is_constant_htmoverblack-rsrc ?const4)
                    (is_constant_endcap-rsrc ?const5)
                    (is_constant_colorcontainer-rsrc ?const12)
                    (is_constant_blackcontainer-rsrc ?const1)
                    (is_constant_blackfeeder-rsrc ?const7)
                    (is_constant_blackprinter-rsrc ?const8)
                    (is_constant_colorfeeder-rsrc ?const9)
                    (is_constant_up-rsrc ?const10)
                    (is_constant_colorprinter-rsrc ?const11)
                    (is_constant_down-rsrc ?const6)
               )
          :effect
               (and
                    (not (uninitialized))
                    (available ?const5)
                    (available ?const4)
                    (available ?const12)
                    (available ?const11)
                    (available ?const9)
                    (available ?const7)
                    (available ?const6)
                    (available ?const2)
                    (available ?const1)
                    (available ?const8)
                    (available ?const10)
                    (available ?const0)
                    (available ?const3)
               )
  )
  (:action endcap-move-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - size_t
               ?const1 - resource_t
               ?const2 - location_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const1)
                    (sheetsize ?sheet ?const0)
                    (location ?sheet ?const2)
                    (is_constant_endcap-rsrc ?const1)
                    (is_constant_endcap_entry-blackcontainer_exit ?const2)
                    (is_constant_htmoverblack_entry-endcap_exit ?const3)
                    (is_constant_letter ?const0)
               )
          :effect
               (and
                    (not (available ?const1))
                    (location ?sheet ?const3)
                    (not (location ?sheet ?const2))
                    (available ?const1)
                    (increase (total-cost) 2000)
               )
  )
  (:action htmoverblack-move-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - resource_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const2)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const3)
                    (is_constant_htmoverblack-rsrc ?const2)
                    (is_constant_htmoverblack_exit-down_topentry ?const0)
                    (is_constant_htmoverblack_entry-endcap_exit ?const3)
                    (is_constant_letter ?const1)
               )
          :effect
               (and
                    (not (available ?const2))
                    (location ?sheet ?const0)
                    (not (location ?sheet ?const3))
                    (available ?const2)
                    (increase (total-cost) 17999)
               )
  )
  (:action colorcontainer-toime-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - size_t
               ?const1 - resource_t
               ?const2 - location_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const1)
                    (sheetsize ?sheet ?const0)
                    (location ?sheet ?const2)
                    (is_constant_colorcontainer-rsrc ?const1)
                    (is_constant_colorcontainer_entry-down_bottomexit ?const2)
                    (is_constant_letter ?const0)
                    (is_constant_colorcontainer_exittoime-colorprinter_entry ?const3)
               )
          :effect
               (and
                    (not (available ?const1))
                    (location ?sheet ?const3)
                    (not (location ?sheet ?const2))
                    (available ?const1)
                    (increase (total-cost) 8000)
               )
  )
  (:action colorcontainer-fromime-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - resource_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const2)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const3)
                    (is_constant_colorcontainer-rsrc ?const2)
                    (is_constant_colorcontainer_exit-up_bottomentry ?const0)
                    (is_constant_colorprinter_exit-colorcontainer_entryfromime ?const3)
                    (is_constant_letter ?const1)
               )
          :effect
               (and
                    (not (available ?const2))
                    (location ?sheet ?const0)
                    (not (location ?sheet ?const3))
                    (available ?const2)
                    (increase (total-cost) 8000)
               )
  )
  (:action colorprinter-simplex-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?image - image_t
               ?const0 - color_t
               ?const1 - resource_t
               ?const2 - location_t
               ?const3 - size_t
               ?const4 - location_t
               )
          :precondition
               (and
                    (available ?const1)
                    (sheetsize ?sheet ?const3)
                    (sideup ?sheet ?face)
                    (imagecolor ?image ?const0)
                    (location ?sheet ?const2)
                    (notprintedwith ?sheet ?face ?const0)
                    (is_constant_color ?const0)
                    (is_constant_colorprinter-rsrc ?const1)
                    (is_constant_colorprinter_exit-colorcontainer_entryfromime ?const4)
                    (is_constant_letter ?const3)
                    (is_constant_colorcontainer_exittoime-colorprinter_entry ?const2)
               )
          :effect
               (and
                    (not (available ?const1))
                    (location ?sheet ?const4)
                    (hasimage ?sheet ?face ?image)
                    (not (location ?sheet ?const2))
                    (not (notprintedwith ?sheet ?face ?const0))
                    (available ?const1)
                    (increase (total-cost) 224040)
               )
  )
  (:action colorprinter-simplexmono-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?image - image_t
               ?const0 - resource_t
               ?const1 - location_t
               ?const2 - color_t
               ?const3 - size_t
               ?const4 - location_t
               )
          :precondition
               (and
                    (available ?const0)
                    (sheetsize ?sheet ?const3)
                    (sideup ?sheet ?face)
                    (imagecolor ?image ?const2)
                    (location ?sheet ?const1)
                    (notprintedwith ?sheet ?face ?const2)
                    (is_constant_colorprinter-rsrc ?const0)
                    (is_constant_black ?const2)
                    (is_constant_colorprinter_exit-colorcontainer_entryfromime ?const4)
                    (is_constant_letter ?const3)
                    (is_constant_colorcontainer_exittoime-colorprinter_entry ?const1)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const4)
                    (hasimage ?sheet ?face ?image)
                    (not (location ?sheet ?const1))
                    (not (notprintedwith ?sheet ?face ?const2))
                    (available ?const0)
                    (increase (total-cost) 224040)
               )
  )
  (:action colorfeeder-feed-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - resource_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - side_t
               ?const4 - location_t
               )
          :precondition
               (and
                    (available ?const0)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const4)
                    (is_constant_front ?const3)
                    (is_constant_colorfeeder-rsrc ?const0)
                    (is_constant_some_feeder_tray ?const4)
                    (is_constant_letter ?const1)
                    (is_constant_down_bottomentry-colorfeeder_exit ?const2)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const2)
                    (sideup ?sheet ?const3)
                    (not (location ?sheet ?const4))
                    (available ?const0)
                    (increase (total-cost) 8000)
               )
  )
  (:action blackfeeder-feed-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - size_t
               ?const1 - side_t
               ?const2 - resource_t
               ?const3 - location_t
               ?const4 - location_t
               )
          :precondition
               (and
                    (available ?const2)
                    (sheetsize ?sheet ?const0)
                    (location ?sheet ?const4)
                    (is_constant_front ?const1)
                    (is_constant_blackcontainer_entry-blackfeeder_exit ?const3)
                    (is_constant_blackfeeder-rsrc ?const2)
                    (is_constant_letter ?const0)
                    (is_constant_some_feeder_tray ?const4)
               )
          :effect
               (and
                    (not (available ?const2))
                    (location ?sheet ?const3)
                    (sideup ?sheet ?const1)
                    (not (location ?sheet ?const4))
                    (available ?const2)
                    (increase (total-cost) 8000)
               )
  )
  (:action down-movetop-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - location_t
               ?const2 - size_t
               ?const3 - resource_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const2)
                    (location ?sheet ?const1)
                    (is_constant_down_topexit-htmovercolor_entry ?const0)
                    (is_constant_down-rsrc ?const3)
                    (is_constant_letter ?const2)
                    (is_constant_htmoverblack_exit-down_topentry ?const1)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const0)
                    (not (location ?sheet ?const1))
                    (available ?const3)
                    (increase (total-cost) 2999)
               )
  )
  (:action down-movebottom-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - resource_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const0)
                    (is_constant_down_bottomentry-colorfeeder_exit ?const0)
                    (is_constant_colorcontainer_entry-down_bottomexit ?const2)
                    (is_constant_down-rsrc ?const3)
                    (is_constant_letter ?const1)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const2)
                    (not (location ?sheet ?const0))
                    (available ?const3)
                    (increase (total-cost) 2999)
               )
  )
  (:action down-movedown-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - resource_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const0)
                    (is_constant_colorcontainer_entry-down_bottomexit ?const2)
                    (is_constant_htmoverblack_exit-down_topentry ?const0)
                    (is_constant_down-rsrc ?const3)
                    (is_constant_letter ?const1)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const2)
                    (not (location ?sheet ?const0))
                    (available ?const3)
                    (increase (total-cost) 9999)
               )
  )
  (:action htmovercolor-move-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - resource_t
               ?const2 - size_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const1)
                    (sheetsize ?sheet ?const2)
                    (location ?sheet ?const0)
                    (is_constant_htmovercolor_exit-up_topentry ?const3)
                    (is_constant_down_topexit-htmovercolor_entry ?const0)
                    (is_constant_htmovercolor-rsrc ?const1)
                    (is_constant_letter ?const2)
               )
          :effect
               (and
                    (not (available ?const1))
                    (location ?sheet ?const3)
                    (not (location ?sheet ?const0))
                    (available ?const1)
                    (increase (total-cost) 9999)
               )
  )
  (:action blackcontainer-toime-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - resource_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const2)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const3)
                    (is_constant_blackcontainer_exittoime-blackprinter_entry ?const0)
                    (is_constant_blackcontainer-rsrc ?const2)
                    (is_constant_blackcontainer_entry-blackfeeder_exit ?const3)
                    (is_constant_letter ?const1)
               )
          :effect
               (and
                    (not (available ?const2))
                    (location ?sheet ?const0)
                    (not (location ?sheet ?const3))
                    (available ?const2)
                    (increase (total-cost) 2000)
               )
  )
  (:action blackcontainer-fromime-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - resource_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const0)
                    (is_constant_endcap_entry-blackcontainer_exit ?const2)
                    (is_constant_blackcontainer-rsrc ?const3)
                    (is_constant_letter ?const1)
                    (is_constant_blackprinter_exit-blackcontainer_entryfromime ?const0)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const2)
                    (not (location ?sheet ?const0))
                    (available ?const3)
                    (increase (total-cost) 2000)
               )
  )
  (:action blackprinter-simplex-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?image - image_t
               ?const0 - location_t
               ?const1 - location_t
               ?const2 - resource_t
               ?const3 - color_t
               ?const4 - size_t
               )
          :precondition
               (and
                    (available ?const2)
                    (sheetsize ?sheet ?const4)
                    (sideup ?sheet ?face)
                    (imagecolor ?image ?const3)
                    (location ?sheet ?const0)
                    (notprintedwith ?sheet ?face ?const3)
                    (is_constant_letter ?const4)
                    (is_constant_blackcontainer_exittoime-blackprinter_entry ?const0)
                    (is_constant_black ?const3)
                    (is_constant_blackprinter-rsrc ?const2)
                    (is_constant_blackprinter_exit-blackcontainer_entryfromime ?const1)
               )
          :effect
               (and
                    (not (available ?const2))
                    (location ?sheet ?const1)
                    (hasimage ?sheet ?face ?image)
                    (not (location ?sheet ?const0))
                    (not (notprintedwith ?sheet ?face ?const3))
                    (available ?const2)
                    (increase (total-cost) 113013)
               )
  )
  (:action blackprinter-simplexandinvert-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?otherface - side_t
               ?image - image_t
               ?const0 - location_t
               ?const1 - location_t
               ?const2 - resource_t
               ?const3 - color_t
               ?const4 - size_t
               )
          :precondition
               (and
                    (available ?const2)
                    (sheetsize ?sheet ?const4)
                    (oppositeside ?face ?otherface)
                    (imagecolor ?image ?const3)
                    (location ?sheet ?const0)
                    (notprintedwith ?sheet ?face ?const3)
                    (sideup ?sheet ?face)
                    (is_constant_letter ?const4)
                    (is_constant_blackcontainer_exittoime-blackprinter_entry ?const0)
                    (is_constant_black ?const3)
                    (is_constant_blackprinter-rsrc ?const2)
                    (is_constant_blackprinter_exit-blackcontainer_entryfromime ?const1)
               )
          :effect
               (and
                    (not (available ?const2))
                    (location ?sheet ?const1)
                    (sideup ?sheet ?otherface)
                    (hasimage ?sheet ?face ?image)
                    (not (location ?sheet ?const0))
                    (not (notprintedwith ?sheet ?face ?const3))
                    (not (sideup ?sheet ?face))
                    (available ?const2)
                    (increase (total-cost) 123013)
               )
  )
  (:action up-movetop-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - resource_t
               ?const1 - location_t
               ?const2 - size_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const0)
                    (sheetsize ?sheet ?const2)
                    (location ?sheet ?const1)
                    (is_constant_finisher1_entry-up_topexit ?const3)
                    (is_constant_up-rsrc ?const0)
                    (is_constant_htmovercolor_exit-up_topentry ?const1)
                    (is_constant_letter ?const2)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const3)
                    (not (location ?sheet ?const1))
                    (available ?const0)
                    (increase (total-cost) 2999)
               )
  )
  (:action up-moveup-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - resource_t
               ?const2 - size_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const1)
                    (sheetsize ?sheet ?const2)
                    (location ?sheet ?const0)
                    (is_constant_colorcontainer_exit-up_bottomentry ?const0)
                    (is_constant_up-rsrc ?const1)
                    (is_constant_finisher1_entry-up_topexit ?const3)
                    (is_constant_letter ?const2)
               )
          :effect
               (and
                    (not (available ?const1))
                    (location ?sheet ?const3)
                    (not (location ?sheet ?const0))
                    (available ?const1)
                    (increase (total-cost) 9999)
               )
  )
  (:action finisher1-passthrough-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - resource_t
               ?const1 - location_t
               ?const2 - size_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const0)
                    (sheetsize ?sheet ?const2)
                    (location ?sheet ?const3)
                    (is_constant_finisher1-rsrc ?const0)
                    (is_constant_finisher2_entry-finisher1_exit ?const1)
                    (is_constant_finisher1_entry-up_topexit ?const3)
                    (is_constant_letter ?const2)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const1)
                    (not (location ?sheet ?const3))
                    (available ?const0)
                    (increase (total-cost) 8000)
               )
  )
  (:action finisher1-stack-letter
          :parameters (
               ?sheet - sheet_t
               ?prevsheet - sheet_t
               ?const0 - resource_t
               ?const1 - location_t
               ?const2 - location_t
               ?const3 - location_t
               ?const4 - size_t
               )
          :precondition
               (and
                    (available ?const0)
                    (prevsheet ?sheet ?prevsheet)
                    (location ?prevsheet ?const1)
                    (sheetsize ?sheet ?const4)
                    (location ?sheet ?const3)
                    (is_constant_finisher1-rsrc ?const0)
                    (is_constant_finisher1_entry-up_topexit ?const3)
                    (is_constant_some_finisher_tray ?const1)
                    (is_constant_letter ?const4)
                    (is_constant_finisher1_tray ?const2)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const1)
                    (stackedin ?sheet ?const2)
                    (not (location ?sheet ?const3))
                    (available ?const0)
                    (increase (total-cost) 8000)
               )
  )
  (:action finisher2-passthrough-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - location_t
               ?const2 - resource_t
               ?const3 - size_t
               )
          :precondition
               (and
                    (available ?const2)
                    (sheetsize ?sheet ?const3)
                    (location ?sheet ?const0)
                    (is_constant_finisher2_entry-finisher1_exit ?const0)
                    (is_constant_finisher2_exit ?const1)
                    (is_constant_finisher2-rsrc ?const2)
                    (is_constant_letter ?const3)
               )
          :effect
               (and
                    (not (available ?const2))
                    (location ?sheet ?const1)
                    (not (location ?sheet ?const0))
                    (available ?const2)
                    (increase (total-cost) 8000)
               )
  )
  (:action finisher2-stack-letter
          :parameters (
               ?sheet - sheet_t
               ?prevsheet - sheet_t
               ?const0 - location_t
               ?const1 - resource_t
               ?const2 - location_t
               ?const3 - location_t
               ?const4 - size_t
               )
          :precondition
               (and
                    (available ?const1)
                    (prevsheet ?sheet ?prevsheet)
                    (location ?prevsheet ?const0)
                    (sheetsize ?sheet ?const4)
                    (location ?sheet ?const3)
                    (is_constant_finisher2_entry-finisher1_exit ?const3)
                    (is_constant_some_finisher_tray ?const0)
                    (is_constant_finisher2-rsrc ?const1)
                    (is_constant_letter ?const4)
                    (is_constant_finisher2_tray ?const2)
               )
          :effect
               (and
                    (not (available ?const1))
                    (location ?sheet ?const0)
                    (stackedin ?sheet ?const2)
                    (not (location ?sheet ?const3))
                    (available ?const1)
                    (increase (total-cost) 8000)
               )
  )
)
