(define (domain etipp)
  (:requirements :typing :fluents)
  (:types
          size_t - object
          location_t - object
          side_t - object
          color_t - object
          image_t - object
          resource_t - object
          sheet_t - object
  )
  (:predicates
          (sheetsize ?sheet - sheet_t ?size - size_t)
          (location ?sheet - sheet_t ?location - location_t)
          (hasimage ?sheet - sheet_t ?side - side_t ?image - image_t)
          (sideup ?sheet - sheet_t ?side - side_t)
          (stackedin ?sheet - sheet_t ?location - location_t)
          (imagecolor ?image - image_t ?color - color_t)
          (notprintedwith ?sheet - sheet_t ?side - side_t ?color - color_t)
          (oppositeside ?side1 - side_t ?side2 - side_t)
          (available ?resource - resource_t)
          (prevsheet ?sheet1 - sheet_t ?sheet2 - sheet_t)
          (uninitialized )
          (is_constant_letter ?x - size_t)
          (is_constant_black ?x - color_t)
          (is_constant_color ?x - color_t)
          (is_constant_front ?x - side_t)
          (is_constant_back ?x - side_t)
          (is_constant_some_feeder_tray ?x - location_t)
          (is_constant_some_finisher_tray ?x - location_t)
          (is_constant_fe1_exit-im1_feedentry ?x - location_t)
          (is_constant_rh1_exit-im1_returnentry ?x - location_t)
          (is_constant_uc1_entry-im1_topexit ?x - location_t)
          (is_constant_im1_bottomexit-lc1_entry ?x - location_t)
          (is_constant_ube_entry-uc1_offramp ?x - location_t)
          (is_constant_uc1_onramp-ube_exit ?x - location_t)
          (is_constant_uc2_entry-uc1_exit ?x - location_t)
          (is_constant_lbe_entry-lc1_offramp ?x - location_t)
          (is_constant_lc1_onramp-lbe_exit ?x - location_t)
          (is_constant_lc1_exit-lc2_entry ?x - location_t)
          (is_constant_rh1_entry-rh2_exit ?x - location_t)
          (is_constant_ure_entry-uc2_offramp ?x - location_t)
          (is_constant_ure_exit-uc2_onramp ?x - location_t)
          (is_constant_uc2_exit-om_topentry ?x - location_t)
          (is_constant_ure_rodantray1 ?x - location_t)
          (is_constant_ure_rodantray2 ?x - location_t)
          (is_constant_lre_entry-lc2_offramp ?x - location_t)
          (is_constant_lc2_onramp-lre_exit ?x - location_t)
          (is_constant_om_bottomentry-lc2_exit ?x - location_t)
          (is_constant_lre_rodantray1 ?x - location_t)
          (is_constant_lre_rodantray2 ?x - location_t)
          (is_constant_om_returnexit-rh2_entry ?x - location_t)
          (is_constant_om_outputexit-sys_entry ?x - location_t)
          (is_constant_sys_outputtray ?x - location_t)
          (is_constant_fe1-rsrc ?x - resource_t)
          (is_constant_im1-rsrc ?x - resource_t)
          (is_constant_uc1-rsrc ?x - resource_t)
          (is_constant_ube-rsrc ?x - resource_t)
          (is_constant_lc1-rsrc ?x - resource_t)
          (is_constant_lbe-rsrc ?x - resource_t)
          (is_constant_rh1-rsrc ?x - resource_t)
          (is_constant_uc2-rsrc ?x - resource_t)
          (is_constant_ure-rsrc ?x - resource_t)
          (is_constant_lc2-rsrc ?x - resource_t)
          (is_constant_lre-rsrc ?x - resource_t)
          (is_constant_rh2-rsrc ?x - resource_t)
          (is_constant_om-rsrc ?x - resource_t)
          (is_constant_sys-rsrc ?x - resource_t)
          )
  (:functions
          (total-cost ) 
          )
  (:action initialize
          :parameters (
               ?const0 - resource_t
               ?const1 - resource_t
               ?const2 - resource_t
               ?const3 - resource_t
               ?const4 - resource_t
               ?const5 - resource_t
               ?const6 - resource_t
               ?const7 - resource_t
               ?const8 - resource_t
               ?const9 - resource_t
               ?const10 - resource_t
               ?const11 - resource_t
               ?const12 - resource_t
               ?const13 - resource_t
               )
          :precondition
               (and
                    (uninitialized)
                    (is_constant_im1-rsrc ?const0)
                    (is_constant_rh2-rsrc ?const1)
                    (is_constant_lc2-rsrc ?const2)
                    (is_constant_om-rsrc ?const3)
                    (is_constant_rh1-rsrc ?const4)
                    (is_constant_fe1-rsrc ?const5)
                    (is_constant_ure-rsrc ?const6)
                    (is_constant_uc2-rsrc ?const7)
                    (is_constant_lbe-rsrc ?const8)
                    (is_constant_uc1-rsrc ?const9)
                    (is_constant_sys-rsrc ?const10)
                    (is_constant_lre-rsrc ?const11)
                    (is_constant_lc1-rsrc ?const12)
                    (is_constant_ube-rsrc ?const13)
               )
          :effect
               (and
                    (not (uninitialized))
                    (available ?const5)
                    (available ?const0)
                    (available ?const9)
                    (available ?const13)
                    (available ?const12)
                    (available ?const8)
                    (available ?const4)
                    (available ?const7)
                    (available ?const6)
                    (available ?const2)
                    (available ?const11)
                    (available ?const1)
                    (available ?const3)
                    (available ?const10)
               )
  )
  (:action fe1-feedmsi-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - side_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - resource_t
               ?const4 - location_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const4)
                    (is_constant_some_feeder_tray ?const4)
                    (is_constant_fe1_exit-im1_feedentry ?const2)
                    (is_constant_back ?const0)
                    (is_constant_letter ?const1)
                    (is_constant_fe1-rsrc ?const3)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const2)
                    (sideup ?sheet ?const0)
                    (not (location ?sheet ?const4))
                    (available ?const3)
                    (increase (total-cost) 500)
               )
  )
  (:action fe1-feed-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - side_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - resource_t
               ?const4 - location_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const4)
                    (is_constant_some_feeder_tray ?const4)
                    (is_constant_fe1_exit-im1_feedentry ?const2)
                    (is_constant_back ?const0)
                    (is_constant_letter ?const1)
                    (is_constant_fe1-rsrc ?const3)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const2)
                    (sideup ?sheet ?const0)
                    (not (location ?sheet ?const4))
                    (available ?const3)
                    (increase (total-cost) 899)
               )
  )
  (:action im1-moveupper-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - resource_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const0)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const3)
                    (is_constant_im1-rsrc ?const0)
                    (is_constant_uc1_entry-im1_topexit ?const2)
                    (is_constant_fe1_exit-im1_feedentry ?const3)
                    (is_constant_letter ?const1)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const2)
                    (not (location ?sheet ?const3))
                    (available ?const0)
                    (increase (total-cost) 8171)
               )
  )
  (:action im1-movelower-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - resource_t
               ?const1 - location_t
               ?const2 - size_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const0)
                    (sheetsize ?sheet ?const2)
                    (location ?sheet ?const3)
                    (is_constant_im1-rsrc ?const0)
                    (is_constant_im1_bottomexit-lc1_entry ?const1)
                    (is_constant_fe1_exit-im1_feedentry ?const3)
                    (is_constant_letter ?const2)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const1)
                    (not (location ?sheet ?const3))
                    (available ?const0)
                    (increase (total-cost) 3088)
               )
  )
  (:action im1-loopupper-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - resource_t
               ?const1 - location_t
               ?const2 - size_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const0)
                    (sheetsize ?sheet ?const2)
                    (location ?sheet ?const1)
                    (is_constant_im1-rsrc ?const0)
                    (is_constant_uc1_entry-im1_topexit ?const3)
                    (is_constant_rh1_exit-im1_returnentry ?const1)
                    (is_constant_letter ?const2)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const3)
                    (not (location ?sheet ?const1))
                    (available ?const0)
                    (increase (total-cost) 8164)
               )
  )
  (:action im1-looplower-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - resource_t
               ?const1 - location_t
               ?const2 - location_t
               ?const3 - size_t
               )
          :precondition
               (and
                    (available ?const0)
                    (sheetsize ?sheet ?const3)
                    (location ?sheet ?const2)
                    (is_constant_im1-rsrc ?const0)
                    (is_constant_im1_bottomexit-lc1_entry ?const1)
                    (is_constant_rh1_exit-im1_returnentry ?const2)
                    (is_constant_letter ?const3)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const1)
                    (not (location ?sheet ?const2))
                    (available ?const0)
                    (increase (total-cost) 3131)
               )
  )
  (:action uc1-fmove-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - size_t
               ?const1 - resource_t
               ?const2 - location_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const1)
                    (sheetsize ?sheet ?const0)
                    (location ?sheet ?const2)
                    (is_constant_uc2_entry-uc1_exit ?const3)
                    (is_constant_uc1_entry-im1_topexit ?const2)
                    (is_constant_uc1-rsrc ?const1)
                    (is_constant_letter ?const0)
               )
          :effect
               (and
                    (not (available ?const1))
                    (location ?sheet ?const3)
                    (not (location ?sheet ?const2))
                    (available ?const1)
                    (increase (total-cost) 10890)
               )
  )
  (:action uc1-divert-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?otherface - side_t
               ?const0 - size_t
               ?const1 - resource_t
               ?const2 - location_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const1)
                    (sheetsize ?sheet ?const0)
                    (oppositeside ?face ?otherface)
                    (location ?sheet ?const2)
                    (sideup ?sheet ?face)
                    (is_constant_uc1_entry-im1_topexit ?const2)
                    (is_constant_ube_entry-uc1_offramp ?const3)
                    (is_constant_uc1-rsrc ?const1)
                    (is_constant_letter ?const0)
               )
          :effect
               (and
                    (not (available ?const1))
                    (location ?sheet ?const3)
                    (sideup ?sheet ?otherface)
                    (not (location ?sheet ?const2))
                    (not (sideup ?sheet ?face))
                    (available ?const1)
                    (increase (total-cost) 11805)
               )
  )
  (:action uc1-merge-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - resource_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const2)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const0)
                    (is_constant_uc2_entry-uc1_exit ?const3)
                    (is_constant_uc1_onramp-ube_exit ?const0)
                    (is_constant_uc1-rsrc ?const2)
                    (is_constant_letter ?const1)
               )
          :effect
               (and
                    (not (available ?const2))
                    (location ?sheet ?const3)
                    (not (location ?sheet ?const0))
                    (available ?const2)
                    (increase (total-cost) 27709)
               )
  )
  (:action uc1-mergeinvert-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?otherface - side_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - resource_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const2)
                    (sheetsize ?sheet ?const1)
                    (oppositeside ?face ?otherface)
                    (location ?sheet ?const0)
                    (sideup ?sheet ?face)
                    (is_constant_uc2_entry-uc1_exit ?const3)
                    (is_constant_uc1_onramp-ube_exit ?const0)
                    (is_constant_uc1-rsrc ?const2)
                    (is_constant_letter ?const1)
               )
          :effect
               (and
                    (not (available ?const2))
                    (location ?sheet ?const3)
                    (sideup ?sheet ?otherface)
                    (not (location ?sheet ?const0))
                    (not (sideup ?sheet ?face))
                    (available ?const2)
                    (increase (total-cost) 28119)
               )
  )
  (:action ube-simplex-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?image - image_t
               ?const0 - location_t
               ?const1 - color_t
               ?const2 - size_t
               ?const3 - location_t
               ?const4 - resource_t
               )
          :precondition
               (and
                    (available ?const4)
                    (sheetsize ?sheet ?const2)
                    (sideup ?sheet ?face)
                    (imagecolor ?image ?const1)
                    (location ?sheet ?const3)
                    (notprintedwith ?sheet ?face ?const1)
                    (is_constant_uc1_onramp-ube_exit ?const0)
                    (is_constant_black ?const1)
                    (is_constant_ube_entry-uc1_offramp ?const3)
                    (is_constant_letter ?const2)
                    (is_constant_ube-rsrc ?const4)
               )
          :effect
               (and
                    (not (available ?const4))
                    (location ?sheet ?const0)
                    (hasimage ?sheet ?face ?image)
                    (not (location ?sheet ?const3))
                    (not (notprintedwith ?sheet ?face ?const1))
                    (available ?const4)
                    (increase (total-cost) 123749)
               )
  )
  (:action lc1-fmove-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - location_t
               ?const2 - size_t
               ?const3 - resource_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const2)
                    (location ?sheet ?const0)
                    (is_constant_im1_bottomexit-lc1_entry ?const0)
                    (is_constant_lc1_exit-lc2_entry ?const1)
                    (is_constant_lc1-rsrc ?const3)
                    (is_constant_letter ?const2)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const1)
                    (not (location ?sheet ?const0))
                    (available ?const3)
                    (increase (total-cost) 10890)
               )
  )
  (:action lc1-divert-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?otherface - side_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - resource_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const2)
                    (sheetsize ?sheet ?const1)
                    (oppositeside ?face ?otherface)
                    (location ?sheet ?const0)
                    (sideup ?sheet ?face)
                    (is_constant_im1_bottomexit-lc1_entry ?const0)
                    (is_constant_lbe_entry-lc1_offramp ?const3)
                    (is_constant_lc1-rsrc ?const2)
                    (is_constant_letter ?const1)
               )
          :effect
               (and
                    (not (available ?const2))
                    (location ?sheet ?const3)
                    (sideup ?sheet ?otherface)
                    (not (location ?sheet ?const0))
                    (not (sideup ?sheet ?face))
                    (available ?const2)
                    (increase (total-cost) 11805)
               )
  )
  (:action lc1-merge-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - resource_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const2)
                    (is_constant_lc1_onramp-lbe_exit ?const2)
                    (is_constant_lc1_exit-lc2_entry ?const0)
                    (is_constant_lc1-rsrc ?const3)
                    (is_constant_letter ?const1)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const0)
                    (not (location ?sheet ?const2))
                    (available ?const3)
                    (increase (total-cost) 27709)
               )
  )
  (:action lc1-mergeinvert-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?otherface - side_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - resource_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const1)
                    (oppositeside ?face ?otherface)
                    (location ?sheet ?const2)
                    (sideup ?sheet ?face)
                    (is_constant_lc1_onramp-lbe_exit ?const2)
                    (is_constant_lc1_exit-lc2_entry ?const0)
                    (is_constant_lc1-rsrc ?const3)
                    (is_constant_letter ?const1)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const0)
                    (sideup ?sheet ?otherface)
                    (not (location ?sheet ?const2))
                    (not (sideup ?sheet ?face))
                    (available ?const3)
                    (increase (total-cost) 28119)
               )
  )
  (:action lbe-simplex-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?image - image_t
               ?const0 - location_t
               ?const1 - resource_t
               ?const2 - size_t
               ?const3 - color_t
               ?const4 - location_t
               )
          :precondition
               (and
                    (available ?const1)
                    (sheetsize ?sheet ?const2)
                    (sideup ?sheet ?face)
                    (imagecolor ?image ?const3)
                    (location ?sheet ?const4)
                    (notprintedwith ?sheet ?face ?const3)
                    (is_constant_lbe-rsrc ?const1)
                    (is_constant_lc1_onramp-lbe_exit ?const0)
                    (is_constant_lbe_entry-lc1_offramp ?const4)
                    (is_constant_letter ?const2)
                    (is_constant_black ?const3)
               )
          :effect
               (and
                    (not (available ?const1))
                    (location ?sheet ?const0)
                    (hasimage ?sheet ?face ?image)
                    (not (location ?sheet ?const4))
                    (not (notprintedwith ?sheet ?face ?const3))
                    (available ?const1)
                    (increase (total-cost) 123749)
               )
  )
  (:action rh1-returnmove-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - resource_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const2)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const3)
                    (is_constant_rh1-rsrc ?const2)
                    (is_constant_rh1_entry-rh2_exit ?const3)
                    (is_constant_rh1_exit-im1_returnentry ?const0)
                    (is_constant_letter ?const1)
               )
          :effect
               (and
                    (not (available ?const2))
                    (location ?sheet ?const0)
                    (not (location ?sheet ?const3))
                    (available ?const2)
                    (increase (total-cost) 10869)
               )
  )
  (:action uc2-fmove-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - resource_t
               ?const1 - location_t
               ?const2 - size_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const0)
                    (sheetsize ?sheet ?const2)
                    (location ?sheet ?const3)
                    (is_constant_uc2_entry-uc1_exit ?const3)
                    (is_constant_uc2-rsrc ?const0)
                    (is_constant_letter ?const2)
                    (is_constant_uc2_exit-om_topentry ?const1)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const1)
                    (not (location ?sheet ?const3))
                    (available ?const0)
                    (increase (total-cost) 11207)
               )
  )
  (:action uc2-divert-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?otherface - side_t
               ?const0 - location_t
               ?const1 - resource_t
               ?const2 - size_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const1)
                    (sheetsize ?sheet ?const2)
                    (oppositeside ?face ?otherface)
                    (location ?sheet ?const3)
                    (sideup ?sheet ?face)
                    (is_constant_ure_entry-uc2_offramp ?const0)
                    (is_constant_uc2-rsrc ?const1)
                    (is_constant_uc2_entry-uc1_exit ?const3)
                    (is_constant_letter ?const2)
               )
          :effect
               (and
                    (not (available ?const1))
                    (location ?sheet ?const0)
                    (sideup ?sheet ?otherface)
                    (not (location ?sheet ?const3))
                    (not (sideup ?sheet ?face))
                    (available ?const1)
                    (increase (total-cost) 17452)
               )
  )
  (:action uc2-merge-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?otherface - side_t
               ?const0 - resource_t
               ?const1 - location_t
               ?const2 - size_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const0)
                    (sheetsize ?sheet ?const2)
                    (oppositeside ?face ?otherface)
                    (location ?sheet ?const3)
                    (sideup ?sheet ?face)
                    (is_constant_uc2-rsrc ?const0)
                    (is_constant_letter ?const2)
                    (is_constant_uc2_exit-om_topentry ?const1)
                    (is_constant_ure_exit-uc2_onramp ?const3)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const1)
                    (sideup ?sheet ?otherface)
                    (not (location ?sheet ?const3))
                    (not (sideup ?sheet ?face))
                    (available ?const0)
                    (increase (total-cost) 78919)
               )
  )
  (:action uc2-mergeinvert-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - resource_t
               ?const1 - location_t
               ?const2 - size_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const0)
                    (sheetsize ?sheet ?const2)
                    (location ?sheet ?const3)
                    (is_constant_uc2-rsrc ?const0)
                    (is_constant_letter ?const2)
                    (is_constant_uc2_exit-om_topentry ?const1)
                    (is_constant_ure_exit-uc2_onramp ?const3)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const1)
                    (not (location ?sheet ?const3))
                    (available ?const0)
                    (increase (total-cost) 78919)
               )
  )
  (:action ure-simplex-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?image - image_t
               ?const0 - location_t
               ?const1 - location_t
               ?const2 - color_t
               ?const3 - resource_t
               ?const4 - size_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const4)
                    (sideup ?sheet ?face)
                    (imagecolor ?image ?const2)
                    (location ?sheet ?const0)
                    (notprintedwith ?sheet ?face ?const2)
                    (is_constant_color ?const2)
                    (is_constant_ure_entry-uc2_offramp ?const0)
                    (is_constant_ure_exit-uc2_onramp ?const1)
                    (is_constant_letter ?const4)
                    (is_constant_ure-rsrc ?const3)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const1)
                    (hasimage ?sheet ?face ?image)
                    (not (location ?sheet ?const0))
                    (not (notprintedwith ?sheet ?face ?const2))
                    (available ?const3)
                    (increase (total-cost) 211849)
               )
  )
  (:action ure-simplexmono-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?image - image_t
               ?const0 - location_t
               ?const1 - location_t
               ?const2 - resource_t
               ?const3 - color_t
               ?const4 - size_t
               )
          :precondition
               (and
                    (available ?const2)
                    (sheetsize ?sheet ?const4)
                    (sideup ?sheet ?face)
                    (imagecolor ?image ?const3)
                    (location ?sheet ?const0)
                    (notprintedwith ?sheet ?face ?const3)
                    (is_constant_ure_entry-uc2_offramp ?const0)
                    (is_constant_ure_exit-uc2_onramp ?const1)
                    (is_constant_black ?const3)
                    (is_constant_letter ?const4)
                    (is_constant_ure-rsrc ?const2)
               )
          :effect
               (and
                    (not (available ?const2))
                    (location ?sheet ?const1)
                    (hasimage ?sheet ?face ?image)
                    (not (location ?sheet ?const0))
                    (not (notprintedwith ?sheet ?face ?const3))
                    (available ?const2)
                    (increase (total-cost) 211849)
               )
  )
  (:action lc2-fmove-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - resource_t
               ?const1 - location_t
               ?const2 - size_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const0)
                    (sheetsize ?sheet ?const2)
                    (location ?sheet ?const3)
                    (is_constant_lc1_exit-lc2_entry ?const3)
                    (is_constant_lc2-rsrc ?const0)
                    (is_constant_letter ?const2)
                    (is_constant_om_bottomentry-lc2_exit ?const1)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const1)
                    (not (location ?sheet ?const3))
                    (available ?const0)
                    (increase (total-cost) 11207)
               )
  )
  (:action lc2-divert-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?otherface - side_t
               ?const0 - location_t
               ?const1 - resource_t
               ?const2 - size_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const1)
                    (sheetsize ?sheet ?const2)
                    (oppositeside ?face ?otherface)
                    (location ?sheet ?const3)
                    (sideup ?sheet ?face)
                    (is_constant_lre_entry-lc2_offramp ?const0)
                    (is_constant_lc1_exit-lc2_entry ?const3)
                    (is_constant_lc2-rsrc ?const1)
                    (is_constant_letter ?const2)
               )
          :effect
               (and
                    (not (available ?const1))
                    (location ?sheet ?const0)
                    (sideup ?sheet ?otherface)
                    (not (location ?sheet ?const3))
                    (not (sideup ?sheet ?face))
                    (available ?const1)
                    (increase (total-cost) 17452)
               )
  )
  (:action lc2-merge-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?otherface - side_t
               ?const0 - resource_t
               ?const1 - location_t
               ?const2 - size_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const0)
                    (sheetsize ?sheet ?const2)
                    (oppositeside ?face ?otherface)
                    (location ?sheet ?const3)
                    (sideup ?sheet ?face)
                    (is_constant_lc2-rsrc ?const0)
                    (is_constant_letter ?const2)
                    (is_constant_om_bottomentry-lc2_exit ?const1)
                    (is_constant_lc2_onramp-lre_exit ?const3)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const1)
                    (sideup ?sheet ?otherface)
                    (not (location ?sheet ?const3))
                    (not (sideup ?sheet ?face))
                    (available ?const0)
                    (increase (total-cost) 78919)
               )
  )
  (:action lc2-mergeinvert-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - resource_t
               ?const1 - location_t
               ?const2 - size_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const0)
                    (sheetsize ?sheet ?const2)
                    (location ?sheet ?const3)
                    (is_constant_lc2-rsrc ?const0)
                    (is_constant_letter ?const2)
                    (is_constant_om_bottomentry-lc2_exit ?const1)
                    (is_constant_lc2_onramp-lre_exit ?const3)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const1)
                    (not (location ?sheet ?const3))
                    (available ?const0)
                    (increase (total-cost) 78919)
               )
  )
  (:action lre-simplex-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?image - image_t
               ?const0 - location_t
               ?const1 - resource_t
               ?const2 - color_t
               ?const3 - size_t
               ?const4 - location_t
               )
          :precondition
               (and
                    (available ?const1)
                    (sheetsize ?sheet ?const3)
                    (sideup ?sheet ?face)
                    (imagecolor ?image ?const2)
                    (location ?sheet ?const0)
                    (notprintedwith ?sheet ?face ?const2)
                    (is_constant_color ?const2)
                    (is_constant_lre_entry-lc2_offramp ?const0)
                    (is_constant_lre-rsrc ?const1)
                    (is_constant_letter ?const3)
                    (is_constant_lc2_onramp-lre_exit ?const4)
               )
          :effect
               (and
                    (not (available ?const1))
                    (location ?sheet ?const4)
                    (hasimage ?sheet ?face ?image)
                    (not (location ?sheet ?const0))
                    (not (notprintedwith ?sheet ?face ?const2))
                    (available ?const1)
                    (increase (total-cost) 211849)
               )
  )
  (:action lre-simplexmono-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?image - image_t
               ?const0 - location_t
               ?const1 - resource_t
               ?const2 - color_t
               ?const3 - size_t
               ?const4 - location_t
               )
          :precondition
               (and
                    (available ?const1)
                    (sheetsize ?sheet ?const3)
                    (sideup ?sheet ?face)
                    (imagecolor ?image ?const2)
                    (location ?sheet ?const0)
                    (notprintedwith ?sheet ?face ?const2)
                    (is_constant_lre_entry-lc2_offramp ?const0)
                    (is_constant_lc2_onramp-lre_exit ?const4)
                    (is_constant_lre-rsrc ?const1)
                    (is_constant_letter ?const3)
                    (is_constant_black ?const2)
               )
          :effect
               (and
                    (not (available ?const1))
                    (location ?sheet ?const4)
                    (hasimage ?sheet ?face ?image)
                    (not (location ?sheet ?const0))
                    (not (notprintedwith ?sheet ?face ?const2))
                    (available ?const1)
                    (increase (total-cost) 211849)
               )
  )
  (:action rh2-returnmove-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - resource_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const0)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const3)
                    (is_constant_rh2-rsrc ?const0)
                    (is_constant_rh1_entry-rh2_exit ?const2)
                    (is_constant_om_returnexit-rh2_entry ?const3)
                    (is_constant_letter ?const1)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const2)
                    (not (location ?sheet ?const3))
                    (available ?const0)
                    (increase (total-cost) 10869)
               )
  )
  (:action om-upperout-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - resource_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const0)
                    (is_constant_om-rsrc ?const3)
                    (is_constant_letter ?const1)
                    (is_constant_uc2_exit-om_topentry ?const0)
                    (is_constant_om_outputexit-sys_entry ?const2)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const2)
                    (not (location ?sheet ?const0))
                    (available ?const3)
                    (increase (total-cost) 8037)
               )
  )
  (:action om-lowerout-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - resource_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const0)
                    (is_constant_om-rsrc ?const3)
                    (is_constant_letter ?const1)
                    (is_constant_om_bottomentry-lc2_exit ?const0)
                    (is_constant_om_outputexit-sys_entry ?const2)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const2)
                    (not (location ?sheet ?const0))
                    (available ?const3)
                    (increase (total-cost) 3251)
               )
  )
  (:action om-upperreturn-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - resource_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const0)
                    (is_constant_om_returnexit-rh2_entry ?const2)
                    (is_constant_letter ?const1)
                    (is_constant_uc2_exit-om_topentry ?const0)
                    (is_constant_om-rsrc ?const3)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const2)
                    (not (location ?sheet ?const0))
                    (available ?const3)
                    (increase (total-cost) 8343)
               )
  )
  (:action om-lowerreturn-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - resource_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const0)
                    (is_constant_om_returnexit-rh2_entry ?const2)
                    (is_constant_letter ?const1)
                    (is_constant_om_bottomentry-lc2_exit ?const0)
                    (is_constant_om-rsrc ?const3)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const2)
                    (not (location ?sheet ?const0))
                    (available ?const3)
                    (increase (total-cost) 3568)
               )
  )
  (:action sys-stack-letter
          :parameters (
               ?sheet - sheet_t
               ?prevsheet - sheet_t
               ?const0 - resource_t
               ?const1 - location_t
               ?const2 - location_t
               ?const3 - size_t
               ?const4 - location_t
               )
          :precondition
               (and
                    (available ?const0)
                    (prevsheet ?sheet ?prevsheet)
                    (location ?prevsheet ?const1)
                    (sheetsize ?sheet ?const3)
                    (location ?sheet ?const2)
                    (is_constant_sys-rsrc ?const0)
                    (is_constant_sys_outputtray ?const4)
                    (is_constant_some_finisher_tray ?const1)
                    (is_constant_letter ?const3)
                    (is_constant_om_outputexit-sys_entry ?const2)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const1)
                    (stackedin ?sheet ?const4)
                    (not (location ?sheet ?const2))
                    (available ?const0)
                    (increase (total-cost) 1499)
               )
  )
)
