(define (domain etipp)
  (:requirements :typing :action-costs)
  (:types
          size_t - object
          location_t - object
          side_t - object
          color_t - object
          image_t - object
          resource_t - object
          sheet_t - object
  )
  (:predicates
          (sheetsize ?sheet - sheet_t ?size - size_t)
          (location ?sheet - sheet_t ?location - location_t)
          (hasimage ?sheet - sheet_t ?side - side_t ?image - image_t)
          (sideup ?sheet - sheet_t ?side - side_t)
          (stackedin ?sheet - sheet_t ?location - location_t)
          (imagecolor ?image - image_t ?color - color_t)
          (notprintedwith ?sheet - sheet_t ?side - side_t ?color - color_t)
          (oppositeside ?side1 - side_t ?side2 - side_t)
          (available ?resource - resource_t)
          (prevsheet ?sheet1 - sheet_t ?sheet2 - sheet_t)
          (uninitialized )
          (is_constant_letter ?x - size_t)
          (is_constant_black ?x - color_t)
          (is_constant_color ?x - color_t)
          (is_constant_front ?x - side_t)
          (is_constant_back ?x - side_t)
          (is_constant_some_feeder_tray ?x - location_t)
          (is_constant_some_finisher_tray ?x - location_t)
          (is_constant_some_purge_tray ?x - location_t)
          (is_constant_fe1_exit-hw1_leftentry ?x - location_t)
          (is_constant_hw1_rightexit-sys_entry ?x - location_t)
          (is_constant_uc1_entry-hw1_topleftexit ?x - location_t)
          (is_constant_lc1_entry-hw1_bottomleftexit ?x - location_t)
          (is_constant_hw1_toprightentry-uc1_exit ?x - location_t)
          (is_constant_lc1_exit-hw1_bottomrightentry ?x - location_t)
          (is_constant_uc1_exittoime-uime_entry ?x - location_t)
          (is_constant_uime_exit-uc1_entryfromime ?x - location_t)
          (is_constant_lime_entry-lc1_exittoime ?x - location_t)
          (is_constant_lc1_entryfromime-lime_exit ?x - location_t)
          (is_constant_sys_outputtray ?x - location_t)
          (is_constant_fe1-rsrc ?x - resource_t)
          (is_constant_hw1-rsrc ?x - resource_t)
          (is_constant_uc1-rsrc ?x - resource_t)
          (is_constant_uime-rsrc ?x - resource_t)
          (is_constant_lc1-rsrc ?x - resource_t)
          (is_constant_lime-rsrc ?x - resource_t)
          (is_constant_sys-rsrc ?x - resource_t)
          )
  (:functions
          (total-cost ) - number
          )
  (:action initialize
          :parameters (
               ?const0 - resource_t
               ?const1 - resource_t
               ?const2 - resource_t
               ?const3 - resource_t
               ?const4 - resource_t
               ?const5 - resource_t
               ?const6 - resource_t
               )
          :precondition
               (and
                    (uninitialized)
                    (is_constant_uime-rsrc ?const0)
                    (is_constant_sys-rsrc ?const1)
                    (is_constant_hw1-rsrc ?const2)
                    (is_constant_fe1-rsrc ?const6)
                    (is_constant_uc1-rsrc ?const3)
                    (is_constant_lime-rsrc ?const4)
                    (is_constant_lc1-rsrc ?const5)
               )
          :effect
               (and
                    (not (uninitialized))
                    (available ?const6)
                    (available ?const2)
                    (available ?const3)
                    (available ?const0)
                    (available ?const5)
                    (available ?const4)
                    (available ?const1)
               )
  )
  (:action fe1-feedmsi-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - side_t
               ?const1 - location_t
               ?const2 - size_t
               ?const3 - resource_t
               ?const4 - location_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const2)
                    (location ?sheet ?const4)
                    (is_constant_fe1_exit-hw1_leftentry ?const1)
                    (is_constant_some_feeder_tray ?const4)
                    (is_constant_back ?const0)
                    (is_constant_letter ?const2)
                    (is_constant_fe1-rsrc ?const3)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const1)
                    (sideup ?sheet ?const0)
                    (not (location ?sheet ?const4))
                    (available ?const3)
                    (increase (total-cost) 125)
               )
  )
  (:action fe1-feed-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - side_t
               ?const1 - location_t
               ?const2 - size_t
               ?const3 - resource_t
               ?const4 - location_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const2)
                    (location ?sheet ?const4)
                    (is_constant_fe1_exit-hw1_leftentry ?const1)
                    (is_constant_some_feeder_tray ?const4)
                    (is_constant_back ?const0)
                    (is_constant_letter ?const2)
                    (is_constant_fe1-rsrc ?const3)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const1)
                    (sideup ?sheet ?const0)
                    (not (location ?sheet ?const4))
                    (available ?const3)
                    (increase (total-cost) 224)
               )
  )
  (:action hw1-leftentrytotopleftexit-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - location_t
               ?const2 - resource_t
               ?const3 - size_t
               )
          :precondition
               (and
                    (available ?const2)
                    (sheetsize ?sheet ?const3)
                    (location ?sheet ?const1)
                    (is_constant_uc1_entry-hw1_topleftexit ?const0)
                    (is_constant_fe1_exit-hw1_leftentry ?const1)
                    (is_constant_hw1-rsrc ?const2)
                    (is_constant_letter ?const3)
               )
          :effect
               (and
                    (not (available ?const2))
                    (location ?sheet ?const0)
                    (not (location ?sheet ?const1))
                    (available ?const2)
                    (increase (total-cost) 1499)
               )
  )
  (:action hw1-leftentrytobottomleftexit-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - resource_t
               ?const2 - size_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const1)
                    (sheetsize ?sheet ?const2)
                    (location ?sheet ?const0)
                    (is_constant_fe1_exit-hw1_leftentry ?const0)
                    (is_constant_hw1-rsrc ?const1)
                    (is_constant_letter ?const2)
                    (is_constant_lc1_entry-hw1_bottomleftexit ?const3)
               )
          :effect
               (and
                    (not (available ?const1))
                    (location ?sheet ?const3)
                    (not (location ?sheet ?const0))
                    (available ?const1)
                    (increase (total-cost) 1499)
               )
  )
  (:action hw1-toprightentrytotopleftexit-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - resource_t
               ?const2 - size_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const1)
                    (sheetsize ?sheet ?const2)
                    (location ?sheet ?const3)
                    (is_constant_uc1_entry-hw1_topleftexit ?const0)
                    (is_constant_hw1-rsrc ?const1)
                    (is_constant_letter ?const2)
                    (is_constant_hw1_toprightentry-uc1_exit ?const3)
               )
          :effect
               (and
                    (not (available ?const1))
                    (location ?sheet ?const0)
                    (not (location ?sheet ?const3))
                    (available ?const1)
                    (increase (total-cost) 8999)
               )
  )
  (:action hw1-toprightentrytobottomleftexit-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - resource_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const0)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const3)
                    (is_constant_hw1_toprightentry-uc1_exit ?const3)
                    (is_constant_hw1-rsrc ?const0)
                    (is_constant_letter ?const1)
                    (is_constant_lc1_entry-hw1_bottomleftexit ?const2)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const2)
                    (not (location ?sheet ?const3))
                    (available ?const0)
                    (increase (total-cost) 8999)
               )
  )
  (:action hw1-bottomrightentrytotopleftexit-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - resource_t
               ?const2 - size_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const1)
                    (sheetsize ?sheet ?const2)
                    (location ?sheet ?const0)
                    (is_constant_lc1_exit-hw1_bottomrightentry ?const0)
                    (is_constant_hw1-rsrc ?const1)
                    (is_constant_letter ?const2)
                    (is_constant_uc1_entry-hw1_topleftexit ?const3)
               )
          :effect
               (and
                    (not (available ?const1))
                    (location ?sheet ?const3)
                    (not (location ?sheet ?const0))
                    (available ?const1)
                    (increase (total-cost) 8999)
               )
  )
  (:action hw1-bottomrightentrytobottomleftexit-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - resource_t
               ?const2 - size_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const1)
                    (sheetsize ?sheet ?const2)
                    (location ?sheet ?const0)
                    (is_constant_lc1_exit-hw1_bottomrightentry ?const0)
                    (is_constant_hw1-rsrc ?const1)
                    (is_constant_letter ?const2)
                    (is_constant_lc1_entry-hw1_bottomleftexit ?const3)
               )
          :effect
               (and
                    (not (available ?const1))
                    (location ?sheet ?const3)
                    (not (location ?sheet ?const0))
                    (available ?const1)
                    (increase (total-cost) 8999)
               )
  )
  (:action hw1-toprightentrytorightexit-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - resource_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const0)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const2)
                    (is_constant_hw1_rightexit-sys_entry ?const3)
                    (is_constant_hw1-rsrc ?const0)
                    (is_constant_letter ?const1)
                    (is_constant_hw1_toprightentry-uc1_exit ?const2)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const3)
                    (not (location ?sheet ?const2))
                    (available ?const0)
                    (increase (total-cost) 1499)
               )
  )
  (:action hw1-bottomrightentrytorightexit-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - resource_t
               ?const2 - size_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const1)
                    (sheetsize ?sheet ?const2)
                    (location ?sheet ?const0)
                    (is_constant_lc1_exit-hw1_bottomrightentry ?const0)
                    (is_constant_hw1-rsrc ?const1)
                    (is_constant_letter ?const2)
                    (is_constant_hw1_rightexit-sys_entry ?const3)
               )
          :effect
               (and
                    (not (available ?const1))
                    (location ?sheet ?const3)
                    (not (location ?sheet ?const0))
                    (available ?const1)
                    (increase (total-cost) 1499)
               )
  )
  (:action uc1-toime-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - resource_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const2)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const0)
                    (is_constant_uc1_exittoime-uime_entry ?const3)
                    (is_constant_uc1_entry-hw1_topleftexit ?const0)
                    (is_constant_uc1-rsrc ?const2)
                    (is_constant_letter ?const1)
               )
          :effect
               (and
                    (not (available ?const2))
                    (location ?sheet ?const3)
                    (not (location ?sheet ?const0))
                    (available ?const2)
                    (increase (total-cost) 2999)
               )
  )
  (:action uc1-inverttoime-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?otherface - side_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - resource_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const2)
                    (sheetsize ?sheet ?const1)
                    (oppositeside ?face ?otherface)
                    (location ?sheet ?const0)
                    (sideup ?sheet ?face)
                    (is_constant_uc1_exittoime-uime_entry ?const3)
                    (is_constant_uc1_entry-hw1_topleftexit ?const0)
                    (is_constant_uc1-rsrc ?const2)
                    (is_constant_letter ?const1)
               )
          :effect
               (and
                    (not (available ?const2))
                    (location ?sheet ?const3)
                    (sideup ?sheet ?otherface)
                    (not (location ?sheet ?const0))
                    (not (sideup ?sheet ?face))
                    (available ?const2)
                    (increase (total-cost) 8000)
               )
  )
  (:action uc1-fromime-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - resource_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const2)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const0)
                    (is_constant_uime_exit-uc1_entryfromime ?const0)
                    (is_constant_uc1-rsrc ?const2)
                    (is_constant_letter ?const1)
                    (is_constant_hw1_toprightentry-uc1_exit ?const3)
               )
          :effect
               (and
                    (not (available ?const2))
                    (location ?sheet ?const3)
                    (not (location ?sheet ?const0))
                    (available ?const2)
                    (increase (total-cost) 2999)
               )
  )
  (:action uc1-invertfromime-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?otherface - side_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - resource_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const2)
                    (sheetsize ?sheet ?const1)
                    (oppositeside ?face ?otherface)
                    (location ?sheet ?const0)
                    (sideup ?sheet ?face)
                    (is_constant_uime_exit-uc1_entryfromime ?const0)
                    (is_constant_uc1-rsrc ?const2)
                    (is_constant_letter ?const1)
                    (is_constant_hw1_toprightentry-uc1_exit ?const3)
               )
          :effect
               (and
                    (not (available ?const2))
                    (location ?sheet ?const3)
                    (sideup ?sheet ?otherface)
                    (not (location ?sheet ?const0))
                    (not (sideup ?sheet ?face))
                    (available ?const2)
                    (increase (total-cost) 8000)
               )
  )
  (:action uime-simplex-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?image - image_t
               ?const0 - resource_t
               ?const1 - location_t
               ?const2 - location_t
               ?const3 - color_t
               ?const4 - size_t
               )
          :precondition
               (and
                    (available ?const0)
                    (sheetsize ?sheet ?const4)
                    (sideup ?sheet ?face)
                    (imagecolor ?image ?const3)
                    (location ?sheet ?const2)
                    (notprintedwith ?sheet ?face ?const3)
                    (is_constant_uime-rsrc ?const0)
                    (is_constant_uime_exit-uc1_entryfromime ?const1)
                    (is_constant_black ?const3)
                    (is_constant_letter ?const4)
                    (is_constant_uc1_exittoime-uime_entry ?const2)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const1)
                    (hasimage ?sheet ?face ?image)
                    (not (location ?sheet ?const2))
                    (not (notprintedwith ?sheet ?face ?const3))
                    (available ?const0)
                    (increase (total-cost) 127790)
               )
  )
  (:action lc1-toime-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - size_t
               ?const1 - location_t
               ?const2 - resource_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const2)
                    (sheetsize ?sheet ?const0)
                    (location ?sheet ?const1)
                    (is_constant_lime_entry-lc1_exittoime ?const3)
                    (is_constant_lc1-rsrc ?const2)
                    (is_constant_letter ?const0)
                    (is_constant_lc1_entry-hw1_bottomleftexit ?const1)
               )
          :effect
               (and
                    (not (available ?const2))
                    (location ?sheet ?const3)
                    (not (location ?sheet ?const1))
                    (available ?const2)
                    (increase (total-cost) 4999)
               )
  )
  (:action lc1-inverttoime-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?otherface - side_t
               ?const0 - size_t
               ?const1 - location_t
               ?const2 - resource_t
               ?const3 - location_t
               )
          :precondition
               (and
                    (available ?const2)
                    (sheetsize ?sheet ?const0)
                    (oppositeside ?face ?otherface)
                    (location ?sheet ?const1)
                    (sideup ?sheet ?face)
                    (is_constant_lime_entry-lc1_exittoime ?const3)
                    (is_constant_lc1-rsrc ?const2)
                    (is_constant_letter ?const0)
                    (is_constant_lc1_entry-hw1_bottomleftexit ?const1)
               )
          :effect
               (and
                    (not (available ?const2))
                    (location ?sheet ?const3)
                    (sideup ?sheet ?otherface)
                    (not (location ?sheet ?const1))
                    (not (sideup ?sheet ?face))
                    (available ?const2)
                    (increase (total-cost) 9999)
               )
  )
  (:action lc1-fromime-letter
          :parameters (
               ?sheet - sheet_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - resource_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const1)
                    (location ?sheet ?const2)
                    (is_constant_lc1_exit-hw1_bottomrightentry ?const0)
                    (is_constant_lc1-rsrc ?const3)
                    (is_constant_letter ?const1)
                    (is_constant_lc1_entryfromime-lime_exit ?const2)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const0)
                    (not (location ?sheet ?const2))
                    (available ?const3)
                    (increase (total-cost) 4999)
               )
  )
  (:action lc1-invertfromime-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?otherface - side_t
               ?const0 - location_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - resource_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const1)
                    (oppositeside ?face ?otherface)
                    (location ?sheet ?const2)
                    (sideup ?sheet ?face)
                    (is_constant_lc1_exit-hw1_bottomrightentry ?const0)
                    (is_constant_lc1-rsrc ?const3)
                    (is_constant_letter ?const1)
                    (is_constant_lc1_entryfromime-lime_exit ?const2)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const0)
                    (sideup ?sheet ?otherface)
                    (not (location ?sheet ?const2))
                    (not (sideup ?sheet ?face))
                    (available ?const3)
                    (increase (total-cost) 9999)
               )
  )
  (:action lime-simplex-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?image - image_t
               ?const0 - color_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - resource_t
               ?const4 - location_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const1)
                    (sideup ?sheet ?face)
                    (imagecolor ?image ?const0)
                    (location ?sheet ?const4)
                    (notprintedwith ?sheet ?face ?const0)
                    (is_constant_color ?const0)
                    (is_constant_lime-rsrc ?const3)
                    (is_constant_lime_entry-lc1_exittoime ?const4)
                    (is_constant_letter ?const1)
                    (is_constant_lc1_entryfromime-lime_exit ?const2)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const2)
                    (hasimage ?sheet ?face ?image)
                    (not (location ?sheet ?const4))
                    (not (notprintedwith ?sheet ?face ?const0))
                    (available ?const3)
                    (increase (total-cost) 212790)
               )
  )
  (:action lime-simplexmono-letter
          :parameters (
               ?sheet - sheet_t
               ?face - side_t
               ?image - image_t
               ?const0 - color_t
               ?const1 - size_t
               ?const2 - location_t
               ?const3 - resource_t
               ?const4 - location_t
               )
          :precondition
               (and
                    (available ?const3)
                    (sheetsize ?sheet ?const1)
                    (sideup ?sheet ?face)
                    (imagecolor ?image ?const0)
                    (location ?sheet ?const4)
                    (notprintedwith ?sheet ?face ?const0)
                    (is_constant_lime-rsrc ?const3)
                    (is_constant_black ?const0)
                    (is_constant_lime_entry-lc1_exittoime ?const4)
                    (is_constant_letter ?const1)
                    (is_constant_lc1_entryfromime-lime_exit ?const2)
               )
          :effect
               (and
                    (not (available ?const3))
                    (location ?sheet ?const2)
                    (hasimage ?sheet ?face ?image)
                    (not (location ?sheet ?const4))
                    (not (notprintedwith ?sheet ?face ?const0))
                    (available ?const3)
                    (increase (total-cost) 212790)
               )
  )
  (:action sys-stack-letter
          :parameters (
               ?sheet - sheet_t
               ?prevsheet - sheet_t
               ?const0 - resource_t
               ?const1 - location_t
               ?const2 - location_t
               ?const3 - size_t
               ?const4 - location_t
               )
          :precondition
               (and
                    (available ?const0)
                    (prevsheet ?sheet ?prevsheet)
                    (location ?prevsheet ?const1)
                    (sheetsize ?sheet ?const3)
                    (location ?sheet ?const2)
                    (is_constant_sys-rsrc ?const0)
                    (is_constant_sys_outputtray ?const4)
                    (is_constant_some_finisher_tray ?const1)
                    (is_constant_hw1_rightexit-sys_entry ?const2)
                    (is_constant_letter ?const3)
               )
          :effect
               (and
                    (not (available ?const0))
                    (location ?sheet ?const1)
                    (stackedin ?sheet ?const4)
                    (not (location ?sheet ?const2))
                    (available ?const0)
                    (increase (total-cost) 1499)
               )
  )
)
