(define (domain crewplanning)
 (:types medicalstate - objects filterstate - objects crewmember - objects payloadact - objects day - objects exerequipment - objects rpcm - objects objects - object)
 (:predicates (mcs_finished ?ps - medicalstate ?d - day) (changed ?fs - filterstate ?d - day) (available ?c - crewmember) (done_sleep ?c - crewmember ?d - day) (done_pre_sleep ?c - crewmember ?d - day) (done_post_sleep ?c - crewmember ?d - day) (done_dpc ?c - crewmember ?d - day) (done_meal ?c - crewmember ?d - day) (done_exercise ?c - crewmember ?d - day) (done_remove_sleep_station ?ps - rpcm) (done_first_reconfigure_thermal_loop ?ps - rpcm) (done_replace_rpcm ?ps - rpcm) (done_assemble_sleep_station ?ps - rpcm) (done_second_reconfigure_thermal_loop ?ps - rpcm) (done_rpcm ?ps - rpcm ?d - day) (payload_act_done ?pa - payloadact) (payload_act_completed ?pa - payloadact ?d - day) (next ?d1 - day ?d2 - day) (currentday ?c - crewmember ?d - day) (initiated ?d - day) (unused ?e - exerequipment))
 (:action initialize_day
  :parameters ( ?d1 - day ?d2 - day)
  :precondition (and (initiated ?d1) (next ?d1 ?d2))
  :effect  (initiated ?d2)
 )
 (:action post_sleep
  :parameters ( ?c - crewmember ?d1 - day ?d2 - day)
  :precondition (and (done_sleep ?c ?d1) (currentday ?c ?d1) (next ?d1 ?d2) (initiated ?d2))
  :effect (and (currentday ?c ?d2) (available ?c) (done_post_sleep ?c ?d2) (not (currentday ?c ?d1)))
 )
 (:action have_meal
  :parameters ( ?c - crewmember ?d - day)
  :precondition (and (available ?c) (done_post_sleep ?c ?d) (currentday ?c ?d))
  :effect  (done_meal ?c ?d)
 )
 (:action exercise
  :parameters ( ?c - crewmember ?d - day ?e - exerequipment)
  :precondition (and (available ?c) (done_post_sleep ?c ?d) (unused ?e) (currentday ?c ?d))
  :effect (and (unused ?e) (done_exercise ?c ?d) (not (unused ?e)))
 )
 (:action sleep
  :parameters ( ?c - crewmember ?d - day)
  :precondition (and (available ?c) (done_exercise ?c ?d) (done_meal ?c ?d) (currentday ?c ?d))
  :effect (and (done_sleep ?c ?d) (not (available ?c)))
 )
 (:action change_filter
  :parameters ( ?fs - filterstate ?c - crewmember ?d - day)
  :precondition (and (available ?c) (currentday ?c ?d))
  :effect  (changed ?fs ?d)
 )
 (:action medical_conference
  :parameters ( ?ps - medicalstate ?c - crewmember ?d - day)
  :precondition (and (available ?c) (currentday ?c ?d))
  :effect  (mcs_finished ?ps ?d)
 )
 (:action conduct_payload_activity
  :parameters ( ?pa - payloadact ?c - crewmember)
  :precondition (available ?c)
  :effect  (payload_act_done ?pa)
 )
 (:action report_payload_activity_at_deadline
  :parameters ( ?pa - payloadact ?c - crewmember ?d - day)
  :precondition (and (currentday ?c ?d) (payload_act_done ?pa))
  :effect  (payload_act_completed ?pa ?d)
 )
 (:action first_reconfigurate_thermal_loops
  :parameters ( ?ps - rpcm ?c - crewmember)
  :precondition (available ?c)
  :effect  (done_first_reconfigure_thermal_loop ?ps)
 )
 (:action remove_sleep_station
  :parameters ( ?ps - rpcm ?c - crewmember)
  :precondition (available ?c)
  :effect  (done_remove_sleep_station ?ps)
 )
 (:action replace_rpcm
  :parameters ( ?ps - rpcm ?c - crewmember)
  :precondition (and (available ?c) (done_remove_sleep_station ?ps) (done_first_reconfigure_thermal_loop ?ps))
  :effect  (done_replace_rpcm ?ps)
 )
 (:action assemble_sleep_station
  :parameters ( ?ps - rpcm ?c - crewmember)
  :precondition (and (available ?c) (done_replace_rpcm ?ps))
  :effect  (done_assemble_sleep_station ?ps)
 )
 (:action second_reconfigurate_thermal_loops
  :parameters ( ?ps - rpcm ?c - crewmember)
  :precondition (and (available ?c) (done_replace_rpcm ?ps))
  :effect  (done_second_reconfigure_thermal_loop ?ps)
 )
 (:action finish_rpcm
  :parameters ( ?ps - rpcm ?c - crewmember ?d - day)
  :precondition (and (done_assemble_sleep_station ?ps) (done_second_reconfigure_thermal_loop ?ps) (currentday ?c ?d))
  :effect  (done_rpcm ?ps ?d)
 )
)
